@echo off
::*************************************************************************************
::V2-0 Created:3-November-2017 09:21 Script Revision-do not delete, edit or move this line
::*************************************************************************************

@ECHO OFF
REM CMD procedure to setup W10spk.vbs script, this file must be in the same folder as w10spk.vbs
REM.-- Prepare the Command Processor
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
::Set w10spk script filename
SET w10spk=w10spk.vbs
IF NOT EXIST %w10spk% (echo %w10spk% script cannot be found^^!, Setup.cmd cannot run, %w10spk% MUST be in the same folder as Setup.cmd) & GOTO noscript
::Set Windows 10 build number dependent default task interval
SET count=1
FOR /F "tokens=* USEBACKQ" %%F IN (`wmic os get buildnumber`) DO (
  SET var!count!=%%F
  SET /a count=!count!+1
)
SET buildnumber=%var2%
IF %buildnumber% GEQ 16299 (SET definterval=60) ELSE (SET definterval=30)

:menuLOOP
cls
echo(
echo(     ============= W10spk Setup Main Menu ======================================================
echo(
for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":menu_" "%~f0""') do echo(  %%B  %%C
set choice=
echo(&set /p choice=">>>> Make a choice [1-8] or press ENTER to quit W10spk Setup: " ||GOTO:EOF
echo(&call:menu_%choice%
GOTO:menuLOOP

::-----------------------------------------------------------
:: menus and subroutines
::-----------------------------------------------------------

:menu_1 Create or Modify the scheduled task to run the W10spk script at a regular interval
CALL :task
GOTO:EOF

:menu_

:menu_2 Create desktop shortcuts to restart the Start Menu or run Setup.cmd
cls
echo(
echo(     ============= Create Desktop Shortcuts =============
echo(
for /f "tokens=1,2,* delims=_ " %%A in ('"findstr /b /c:":SC_" "%~f0""') do echo(  %%B  %%C
set choiceSC=
echo(&set /p choiceSC=">>>> Make a choice [1-3] or press ENTER to quit Create Desktop Shortcuts: " ||GOTO:EOF
echo(&call:SC_%choiceSC%
GOTO:EOF

:SC_1 Create desktop shortcut to restart processes and display Start Menu
cls
set x=11
GOTO:createSC

:SC_

:SC_2 Create desktop shortcut to restart Start Menu processes
cls
set x=10
GOTO:createSC

:SC_

:SC_3 Create desktop shortcut to run w10spk Setup.cmd
cls
set x=12

:createSC
echo Requesting '%W10spk%' create desktop shortcut
echo(
cscript //nologo %w10spk% /x:%x%
echo(
echo Press Enter to return to W10spk Setup Main Menu
pause > nul
GOTO:EOF

:menu_

:menu_3 Disable w10spk scheduled task
cls
echo Requesting '%W10spk%' disable scheduled task
echo(
cscript //nologo %w10spk% /x:30
echo(
echo Press Enter to return to W10spk Setup Main Menu
pause > nul
GOTO:EOF

:menu_

:menu_4 Enable w10spk scheduled task
cls
echo Requesting '%W10spk%' enable scheduled task
echo(
cscript //nologo %w10spk% /x:31
echo(
echo Press Enter to return to W10spk Setup Main Menu
pause > nul
GOTO:EOF

:menu_

:menu_5 Delete w10spk scheduled task
cls
(echo Do you really want to delete the scheduled task?) & (echo()
set reallydel=
set /p reallydel="Enter Y to proceed or press Enter to return to menu: " ||GOTO:EOF
IF /I NOT %reallydel% == y  GOTO:EOF
echo Requesting '%W10spk%' deletes scheduled task
echo(
cscript //nologo %w10spk% /x:32
echo(
echo Press Enter to return to W10spk Setup Main Menu
pause > nul
GOTO:EOF

:menu_

:menu_6 Test Media Center playback status
CALL :playtest
GOTO:EOF

:menu_

:menu_7 Check the Windows 10 processes W10spk is selecting for termination (no actual termination)
cls
echo Requesting '%W10spk%' checks for Windows 10 processes eligible for termination
echo(
cscript //nologo %w10spk% /x:2
echo(
echo Press Enter to return to W10spk Setup Main Menu
pause > nul
GOTO:EOF

:menu_

:menu_8 View the W10spk log file
cls
IF NOT EXIST w10spk_log.txt (echo Cannot find w10spk_log.txt, log does not exist) & GOTO mm
echo Opening log using more command: type Q to quit, ^<space^> to display next page, ^<return^> to display next line, ? for help
pause
more /e /c w10spk_log.txt
:mm
echo(
echo Press Enter to return to W10spk Setup Main Menu
pause > nul
GOTO:EOF

::Subroutines

::Checks if w10spk correctly detects MC status
:playtest

cls
echo(
echo Requesting '%W10spk%' tests Media Center playback status
echo(
cscript //nologo %w10spk% /x:1 > nul
::echo(
IF errorlevel 3 (echo Media Center is NOT open^^! Please launch Media Center and try again^^!) & GOTO playreturn
IF errorlevel 2 (echo w10spk detected Media Center is STOPPED) & GOTO playreturn
IF errorlevel 1 (echo w10spk detected Media Center is PAUSED) & GOTO playreturn
IF errorlevel 0 (echo w10spk detected Media Center is PLAYING) & GOTO playreturn

:playreturn
echo( & (echo Press Enter to return to W10spk Setup Main Menu)
pause > nul
GOTO:EOF

::Gathers input from user and runs w10spk.vbs to create a task with the selected options.
:task
cls
echo Task will be created in the Task Scheduler Library folder w10spk.
echo(
::Let user choose task repeat interval or accept default
echo The default script run interval is %definterval% minutes.
IF %buildnumber% GEQ 16299 (echo The default interval is a very safe value.) & (echo It is recommended to experiment with bigger intervals - up to 300 minutes.)
:invalid
echo(
set interval=
set /p interval="To change the run interval please enter a value in minutes or press Enter to accept default: "||set interval=%definterval%
echo %interval%|findstr /xr "[1-9][0-9]* 0" > nul
IF errorlevel 1 (echo() & (echo ^^!ERROR: Please enter a positive number for task run interval e.g. 20 or 240) & GOTO invalid
IF %interval% EQU %definterval% (set scripti=) ELSE (set scripti=/i:%interval%)
echo(
::Let user choose to enable logging or accept default
echo W10spk can log activity to w10spk_log.txt in the script folder.
echo Events recorded are: Media Center PLAYING status and any process termination activity.
echo The log file is limited to 500 lines in length.
echo The default is logging disabled.
echo(
set /p clos="Enter Y to enable logging or press Enter to accept default: " ||GOTO setdef
IF /I %clos% == y (SET scriptx=21) & GOTO setOK ELSE GOTO setdef

:setdef
set scriptx=20

:setOK
echo(
IF %scriptx% EQU 20 set opt='%w10spk%'
IF %scriptx% EQU 21 set opt='%w10spk% /log'
set text=OK to create/modify task 'w10spk_run_%username%' to run %opt% every %interval% minutes?
::check user wishes to proceed with task creation
:proceed
(echo %text%) & (echo()
set proceed=
set /p proceed="Enter Y to proceed or press Enter to return to menu: " ||GOTO taskmenu
IF /I NOT %proceed% == y  GOTO taskmenu
echo(
echo Requesting '%W10spk%' to create or modify task 'w10spk_run_%username%'
echo(
cscript //nologo %w10spk% /x:%scriptx% %scripti%
echo(
IF %errorlevel% EQU 0 (echo SUCCESS: '%w10spk%' created or modified task 'w10spk_run_%username%') ELSE  (echo FAILURE^^!: Task creation did not complete successfully)
echo( & (echo Press Enter to return to W10spk Setup Main Menu)
pause > nul
GOTO:EOF
:taskmenu
echo( & echo Task 'w10spk_run_%username%' has NOT been created or modified, press Enter to continue
pause > nul
GOTO:EOF

:noscript
pause

:endof